<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
				xmlns:s="library://ns.adobe.com/flex/spark"
				xmlns:ui="library://ns.adobe.com/flex/ui"
				xmlns:mx="library://ns.adobe.com/flex/mx"
				xmlns:components="br.com.dclick.components.*"
				xmlns:componente="br.com.desenv.framework.componente.*"
				close="titlewindowCloseHandler(event)"  creationComplete="titlewindow1_creationCompleteHandler(event)"
				title="Pesquisa de produto" keyDown="titlewindow1_keyDownHandler(event)" windowMove="titlewindow1_windowMoveHandler(event)"
				xmlns:visual="br.com.desenv.framework.component.visual.*"
				height="620" width="600">
	
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	<fx:Metadata>
		[Event(name="EstoqueProdutoSelecionadoEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			
			import spark.events.TitleWindowBoundsEvent;
			
			import br.com.desenv.nepalign.vo.EmpresaFisica;
			import br.com.desenv.nepalign.vo.EstoqueProduto;
			import br.com.desenv.nepalign.vo.Page;
			
			public var estoqueProduto:EstoqueProduto = new EstoqueProduto();
			public var carregarSaldo:Boolean = false;
			public var empresaFisica:EmpresaFisica = null;
			
			[Bindable]
			protected var listEstoqueProduto:ArrayCollection = new ArrayCollection();
			private var pageNumber: int = 1;
			[Bindable]
			private var totalRecords: int;
			private var pageSize: int = 20;
			private var lastPage: int = 1;

			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function titlewindow1_creationCompleteHandler(event:FlexEvent):void
			{
				if(!carregarSaldo)
				{
					var remoteObjectPesquisar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("estoqueProdutoService", this.estoqueProdutoPesquisaResultHandler);	
					
					if(this.estoqueProduto.produto != null)
						remoteObjectPesquisar.getOperation("consultaPorProduto").send(pageSize, 1, this.estoqueProduto); 
					else
						remoteObjectPesquisar.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, this.estoqueProduto);	
				}
				else
				{
					this.width = this.width + 50;
					this.datagridListaEstoqueProduto.width = this.datagridListaEstoqueProduto.width + 50;
					
					AMFConnector.instance.prepararObjetoRemoto("saldoEstoqueProdutoService", this.estoqueProdutoPesquisaResultHandler).getOperation("carregarSaldoEstoqueProdutoPorProduto").send(this.estoqueProduto, this.empresaFisica, 1, pageSize);
				} 
			}
			
			protected function estoqueProdutoPesquisaResultHandler(event:ResultEvent):void
			{
				this.listEstoqueProduto = (event.result as Page).recordList;
				pageNumber = (event.result as Page).pageNumber;
				lastPage = (event.result as Page).lastPage();
				totalRecords = (event.result as Page).totalRecords;
				this.labelPaginaAtual.text = pageNumber.toString();
				focusManager.setFocus(this.datagridListaEstoqueProduto);
			}
			
			protected function datagridListaEstoqueProduto_doubleClickHandler(event:MouseEvent):void
			{
				this.dispatchEvent(new ResultEvent("EstoqueProdutoSelecionadoEvent",false, true, this.datagridListaEstoqueProduto.selectedItem, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function titlewindow1_keyDownHandler(event:KeyboardEvent):void
			{
				if(event.keyCode == 13)	
				{
					this.datagridListaEstoqueProduto_doubleClickHandler(new MouseEvent(""));
				}
				else if(event.keyCode == Keyboard.ESCAPE)
					UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function titlewindow1_windowMoveHandler(event:TitleWindowBoundsEvent):void
			{
				if(this.y < 0)
					this.y = 0;
			}
			
			protected function linkButtonPrimeiraPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectPesquisar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("estoqueProdutoService", this.estoqueProdutoPesquisaResultHandler);	
				
				if(this.estoqueProduto.produto != null)
					remoteObjectPesquisar.getOperation("consultaPorProduto").send(pageSize, 1, this.estoqueProduto); 
				else
					remoteObjectPesquisar.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, this.estoqueProduto); 
			}
			
			protected function linkButtonAnteriorPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectPesquisar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("estoqueProdutoService", this.estoqueProdutoPesquisaResultHandler);	
				
				if(this.estoqueProduto.produto != null)
					remoteObjectPesquisar.getOperation("consultaPorProduto").send(pageSize, pageNumber > 1 ? pageNumber - 1 : pageNumber, this.estoqueProduto); 
				else
					remoteObjectPesquisar.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber > 1 ? pageNumber - 1 : pageNumber, this.estoqueProduto); 
			}
			
			protected function linkButtonProximaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectPesquisar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("estoqueProdutoService", this.estoqueProdutoPesquisaResultHandler);
				
				if(this.estoqueProduto.produto != null)
					remoteObjectPesquisar.getOperation("consultaPorProduto").send(pageSize, pageNumber < lastPage ? pageNumber + 1 : lastPage, this.estoqueProduto); 
				else
					remoteObjectPesquisar.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber < lastPage ? pageNumber + 1 : lastPage, this.estoqueProduto);
			}
			
			protected function linkButtonUltimaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectPesquisar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("estoqueProdutoService", this.estoqueProdutoPesquisaResultHandler);
				
				if(this.estoqueProduto.produto != null)
					remoteObjectPesquisar.getOperation("consultaPorProduto").send(pageSize, lastPage, this.estoqueProduto); 
				else
					remoteObjectPesquisar.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, this.estoqueProduto);
			}
			
			protected function datagridListaEstoqueProduto_creationCompleteHandler(event:FlexEvent):void
			{
				if(this.carregarSaldo)
				{
					var newColumns:Array = new Array();
					
					for(var index:int = 0; index < this.datagridListaEstoqueProduto.columns.length; index++)
					{
						var dataGridColumn:DataGridColumn = this.datagridListaEstoqueProduto.columns[index] as DataGridColumn;
						dataGridColumn.dataField = "estoqueProduto." + dataGridColumn.dataField;
						newColumns.push(dataGridColumn);
					}
					
					var saldoColumn:DataGridColumn = new DataGridColumn();
					saldoColumn.headerText = "Saldo";
					saldoColumn.width = 50;
					saldoColumn.dataField = "saldo";
					
					newColumns.push(saldoColumn);
					
					this.datagridListaEstoqueProduto.columns = newColumns;
				}
			}
			
		]]>
	</fx:Script>
	
	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" width="100%" height="100%">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center" width="100%">
				<mx:LinkButton id="linkButtonPrimeiraPagina" label="&lt;&lt;" click="linkButtonPrimeiraPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonAnteriorPagina" label="&lt;" click="linkButtonAnteriorPagina_clickHandler(event)"/>
				<mx:Label id="labelPaginaAtual" text=""/>
				<mx:LinkButton id="linkButtonProximaPagina" label="&gt;" click="linkButtonProximaPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonUltimaPagina" label="&gt;&gt;" click="linkButtonUltimaPagina_clickHandler(event)"/>				
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<mx:DataGrid id="datagridListaEstoqueProduto" dataProvider="{this.listEstoqueProduto}" doubleClick="datagridListaEstoqueProduto_doubleClickHandler(event)" doubleClickEnabled="true" allowMultipleSelection="false" rowCount="20" creationComplete="datagridListaEstoqueProduto_creationCompleteHandler(event)">
					<mx:columns>
						<mx:DataGridColumn visible="false" dataField="id"/>
						<mx:DataGridColumn dataField="codigoBarras" headerText="Cod. Barras" resizable="true" width="120"/>
						<mx:DataGridColumn dataField="produto.nomeProduto" headerText="Produto" resizable="true" width="150"/>
						<mx:DataGridColumn dataField="tamanho.descricao" headerText="Tamanho" resizable="true"/>
						<mx:DataGridColumn dataField="cor.descricaoCorEmpresa" headerText="Cor" resizable="true"/>
						<mx:DataGridColumn dataField="ordemProduto.descricao" headerText="Ordem Produto" resizable="true"/>
					</mx:columns>
				</mx:DataGrid>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem>
				<s:Label id="labelTotalRegistros" text="Total de registros : {totalRecords}"/>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>